package primer_03_prenos_argumenata;

// Klasa Tacka se nalazi u drugom nasem paketu, primer_02_nasledjivanje,
// pa moramo da je ukljucimo (potpuno isto kao kad nam treba
// klasa standardne biblioteke iz bilo kog paketa osim java.lang)
import primer_02_nasledjivanje.Tacka;

// Argumenti metoda se prenose po vrednosti
// sto znaci da se pravi njihova lokalna kopija

public class Main {

    // Posledica je da metod ne moze da promeni vrednost
    // svog argumenta koji je primitivnog tipa
    public static void inkrement(int n) {
        n++;
        System.out.println("Unutar metoda n = " + n);
    }

    // u slucaju metoda ciji argument je tipa neke klase,
    // argument je referenca na objekat kreira se lokalna kopija,
    // ali te reference, ne samog objekta tako da se izmene
    // vrednosti atributa objekta vrse na samom objektu,
    // a ne na njegovoj lokalnoj kopiji, te ostaju upamcene i po
    // zavrsetku metoda
    public static void promeniTacku(Tacka t,
                                double dx, double dy) {
        t = new Tacka(42, 3);
        // t.pomeriZa(dx, dy);
        System.out.println("U metodu t = " + t);
    }

    public static void main(String[] args) {

        int n = 10;

        System.out.println("Pre metoda n = " + n);
        inkrement(n);
        System.out.println("Posle metoda n = " + n);

        // posle metoda, vrednost je ista kao i pre
        // jer je sve promene metod vrsio nad lokalnom kopijom
        // koja po izlasku iz metoda prestaje da postoji

        Tacka t = new Tacka();

        System.out.println("Pre metoda t = " + t);
        promeniTacku(t, 10, 10);
        System.out.println("Posle metoda t = " + t);

        // promene izvrsene unutar metoda nad vrednostima atributa
        // objekta ostaju upamcene i po izlasku iz metoda
    }
}
